// this sets the background color of the master UIView (when there are no windows/tab groups on it)
Titanium.UI.setBackgroundColor('#000');

// create tab group
var tabGroup = Titanium.UI.createTabGroup();

//
// create base UI tab and root window
//

var win1 = Titanium.UI.createWindow({
    url:'home.js',
    title:'Home Timeline',
    backgroundColor:'#fff'
});

var tab1 = Titanium.UI.createTab({  
    icon:'images/timeline.png',
    title:'Home',
    window:win1
});

var label1 = Titanium.UI.createLabel({
	color:'#999',
	text:'Loading Timeline...',
	font:{fontSize:20,fontFamily:'Helvetica Neue'},
	textAlign:'center',
	width:'auto'
});

win1.add(label1);

var win2 = Titanium.UI.createWindow({  
    url:'mentions.js',
    title:'Mentions',
    backgroundColor:'#fff'
});
var tab2 = Titanium.UI.createTab({  
    icon:'images/mentions.png',
    title:'Mentions',
    window:win2
});

var label2 = Titanium.UI.createLabel({
	color:'#999',
	text:'Loading Mentions...',
	font:{fontSize:20,fontFamily:'Helvetica Neue'},
	textAlign:'center',
	width:'auto'
});

win2.add(label2);

var win3 = Titanium.UI.createWindow({  
    url:'directs.js',
    title:'Loading Direct messages...',
    backgroundColor:'#fff'
});
var tab3 = Titanium.UI.createTab({  
    icon:'images/directs.png',
    title:'Directs',
    window:win3
});

var label3 = Titanium.UI.createLabel({
	color:'#999',
	text:'Direct messages',
	font:{fontSize:20,fontFamily:'Helvetica Neue'},
	textAlign:'center',
	width:'auto'
});

win3.add(label3);


var win4 = Titanium.UI.createWindow({  
    url:'aliases.js',
    title:'Loading Aliases...',
    backgroundColor:'#fff'
});
var tab4 = Titanium.UI.createTab({  
    icon:'images/aliases.png',
    title:'Aliases',
    window:win4
});

var label4 = Titanium.UI.createLabel({
	color:'#999',
	text:'Aliases',
	font:{fontSize:20,fontFamily:'Helvetica Neue'},
	textAlign:'center',
	width:'auto'
});

win4.add(label4);


var win5 = Titanium.UI.createWindow({  
    url:'settings.js',
    title:'Settings',
    backgroundColor:'#fff'
});
var tab5 = Titanium.UI.createTab({  
    icon:'images/settings.png',
    title:'Settings',
    window:win5
});

var label5 = Titanium.UI.createLabel({
	color:'#999',
	text:'Settings',
	font:{fontSize:20,fontFamily:'Helvetica Neue'},
	textAlign:'center',
	width:'auto'
});

win5.add(label5);

var win6 = Titanium.UI.createWindow({  
    url:'setup.js',
    title:'Setup Account',
    backgroundColor:'#fff'
});
var tab6 = Titanium.UI.createTab({  
    icon:'images/settings.png',
    title:'Setup Account',
    window:win6
});

var label6 = Titanium.UI.createLabel({
	color:'#999',
	text:'Setup Account',
	font:{fontSize:20,fontFamily:'Helvetica Neue'},
	textAlign:'center',
	width:'auto'
});

win6.add(label6);


var win7 = Titanium.UI.createWindow({ 
    url:'about.js',
    title:'About',
    backgroundColor:'#fff'
});
var tab7 = Titanium.UI.createTab({  
    icon:'images/about.png',
    title:'About',
    window:win7
});

var label7 = Titanium.UI.createLabel({
	color:'#999',
	text:'About',
	font:{fontSize:20,fontFamily:'Helvetica Neue'},
	textAlign:'center',
	width:'auto'
});

win7.add(label7);

//
//  add tabs
//
tabGroup.addTab(tab1);
tabGroup.addTab(tab2);
tabGroup.addTab(tab3);
tabGroup.addTab(tab4);
tabGroup.addTab(tab5);
tabGroup.addTab(tab6);
tabGroup.addTab(tab7);

//Database stuff

var dbVersion = '0.1.1';

var db = Titanium.Database.install('filttr.db','filttrdb');
var rows = db.execute("SELECT value FROM config WHERE name='dbversion'");
if (rows.isValidRow())
{
	if (dbVersion == rows.field(0))
	{
	    Titanium.API.log('same db version, continue..');
	}
	else
	{
	    Titanium.API.log('time to upgrade??');
	}
}
rows.close();

// open tab group
tabGroup.open();

