var dial = Titanium.UI.createAlertDialog();
var checkDial = Titanium.UI.createAlertDialog({buttonNames:['OK','Cancel']});
var temp = '';
var savedText = '';
var countColor = '';
var win = Titanium.UI.currentWindow;

savedText = Titanium.App.Properties.getString('draftText');
if (savedText==undefined)
{
    savedText = '';
}
else
{
    savedText = String(savedText);
}
var tweetLength = savedText.length;

var closeB = Titanium.UI.createButton({
    systemButton:Titanium.UI.iPhone.SystemButton.STOP,
    style:Titanium.UI.iPhone.SystemButtonStyle.BORDERED
});

var send = Titanium.UI.createButton({
    systemButton:Titanium.UI.iPhone.SystemButton.ACTION,
    style:Titanium.UI.iPhone.SystemButtonStyle.BORDERED
});

var countBox = Titanium.UI.createButton({
  id: 'countBox',
  title: String(140-tweetLength)
});

var photo = Titanium.UI.createButton({
	systemButton:Titanium.UI.iPhone.SystemButton.CAMERA
});

var clearB = Titanium.UI.createButton({
	systemButton:Titanium.UI.iPhone.SystemButton.TRASH
});

var flexSpace = Titanium.UI.createButton({
	systemButton:Titanium.UI.iPhone.SystemButton.FLEXIBLE_SPACE
});

var fixSpace = Titanium.UI.createButton({
	systemButton:Titanium.UI.iPhone.SystemButton.FIXED_SPACE
});

var loading = Titanium.UI.createActivityIndicator({width:100});

var fixSpace = Titanium.UI.createButton({
	systemButton:Titanium.UI.iPhone.SystemButton.FIXED_SPACE
});

var geolocation = Titanium.UI.createButton({
  id:'geolocation',
  image:'images/geotag.png',
  systemButton:Titanium.UI.iPhone.SystemButton.SEARCH,
  height: 30
});

var tcount = Titanium.UI.createButton({
	title:'140'
});

var urlshortener = Titanium.UI.createButton({
	systemButton:Titanium.UI.iPhone.SystemButton.ORGANIZE
});

var tweetBox = Titanium.UI.createTextArea({
    value:savedText,
    top:40,
    font:{fontSize:20, fontWeight:'bold'},
    borderStyle:Titanium.UI.INPUT_BORDERSTYLE_BEZEL,
    keyboardToolbar: [tcount, flexSpace, photo, flexSpace, geolocation, flexSpace, urlshortener, flexSpace, clearB],
	keyboardToolbarHeight:20,
	enableReturnKey:false
});

var navtitle = Titanium.UI.createButton({
	title:'What\'s on your mind?',
	color:'#fff',
	style:Titanium.UI.iPhone.SystemButtonStyle.PLAIN
});

var toolbar = Titanium.UI.createToolbar({
	items:[closeB,flexSpace,navtitle,flexSpace,send],
	top:0,
	borderTop:false,
	borderBottom:true
});

function uploadMedia(image)
{
    navtitle.title = 'Uploading photo...';

    var ch = Titanium.Network.createHTTPClient();
    ch.onload = function()
	{
		Titanium.API.log('Got it.');
		Titanium.API.log('Status: '+this.status);
	    Titanium.API.log('Back : '+this.responseText);
		var resp = eval('('+this.responseText+')');

        if (parseInt(this.status, 10)==200 && (resp.success!=undefined))
        {
			temp = tweetBox.value;
			if (temp!='')
	        {
			    temp += ' ';
		    }
			temp += resp.url;
			tweetBox.setValue(temp);
        }
        else
        {
		    Titanium.API.log('Response: '+resp.error);
            dial.setMessage('Response: '+resp.error);
            dial.show();
        }
		win.setRightNavButton(send);
		navtitle.title = 'What\'s on your mind?';
	};

	var user = String(Titanium.App.Properties.getString('user'));
	var pass = String(Titanium.App.Properties.getString('pass'));

	ch.open('POST','https://oauth.filttr.com/filttrfon_upload.php?im=yes');
	ch.setRequestHeader("Content-Type","multipart/form-data");
	ch.setRequestHeader('Authorization', 'Basic ' + Titanium.Utils.base64encode(user + ':' + pass));

	Titanium.API.log('sending: '+image.url);

	ch.send({media:image});
    
	Titanium.API.log('waiting for response.');
}

photo.addEventListener('click',function()
{
    var dialog = Titanium.UI.createOptionDialog();
    if(Titanium.Platform.model.indexOf("iPhone") > -1 && (Titanium.Platform.model.indexOf("Simulator") == -1))
    {
	    dialog.setOptions(["Use an existing one","Take a new one","Cancel"]);
		dialog.setDestructive(1);
		dialog.setCancel(2);
	}
	else
	{ 
        dialog.setOptions(["Use an existing one","Cancel"]);
		dialog.setCancel(1);
	}

	dialog.setTitle('Attach a photo to your tweet.');
	dialog.addEventListener('click',function(e)
	{
		switch(e.index)
		{
		    case 0:
		        //some photo gallery bug Titanium 1.x
		        //http://developer.appcelerator.com/question/15381/openphotogallery-doesnt-work-in-new-windows
		        Titanium.Media.openPhotoGallery({
        			success: function(event)
        			{
                        tweetBox.focus();
                		setTimeout(function(){
                            tweetBox.focus();
                        }, 500);
            		    uploadMedia(event.media);
        			},
        			cancel: function()
        			{
                        tweetBox.focus();
                        setTimeout(function(){
                            tweetBox.focus();
                        }, 500);
        			},
        			error: function(error)
        			{
                        tweetBox.focus();
    			        setTimeout(function(){
                            tweetBox.focus();
                        }, 500);
    			        Titanium.API.log('error opening photo gallery');
        				dial.setTitle('Error from Gallery');
        				dial.setMessage(error.message);
        				dial.show();
        			},
        			allowEditing:true
        		});
		        break;

		    case 1:
                //I *do* need to add the iPhone check here since dialog.setCancel taking care of it *was a bug*
                if(Titanium.Platform.model.indexOf("iPhone") > -1 && (Titanium.Platform.model.indexOf("Simulator") == -1))
                {
					Titanium.Media.showCamera({
	        			success:function(event)
	        			{
	            		    Titanium.Media.saveToPhotoGallery(event.media);
                            tweetBox.focus();
	            		    setTimeout(function(){
	                            tweetBox.focus();
	                        }, 500);
	        				uploadMedia(event.media);
	        			},
	        			cancel:function()
	        			{
                            tweetBox.focus();
	                        setTimeout(function(){
	                            tweetBox.focus();
	                        }, 500);
	        			},
	        			error:function(error)
	        			{
	        				setTimeout(function(){
	                            tweetBox.focus();
	                        }, 500);
	                        dial.setTitle('Camera Error');
	        				if (error.code == Titanium.Media.NO_CAMERA)
	        				{
	        					dial.setMessage('Device does not have camera');
	        				}
	        				else
	        				{
	        					dial.setMessage('Unexpected error: ' + error.code);
	        				}
	        				dial.show();
	        			},
	        			allowEditing:true
	        		});
				}
		        break;
		}
	});
	dialog.show();

});

function geoTagIt()
{
    var geotag = Titanium.App.Properties.getString('geotag');
    if (geotag!=undefined && geotag!='')
	{
	    Titanium.App.Properties.setString('geotag', '');
        dial.setMessage('The geo-tag on the tweet has been removed!');
        dial.show();
    }
    else
    {
        Titanium.Geolocation.accuracy = Titanium.Geolocation.ACCURACY_BEST;
        Titanium.Geolocation.purpose = 'to geotag tweets';
        Titanium.Geolocation.getCurrentPosition(
            function(pos) {
                if (pos.error)
        		{
        			Titanium.API.log('GEO error'+pos.error);
                    dial.setMessage('Sorry, couldn\'t retrieve your location. Please try again later.');
                    dial.show();
        			return;
        		}
                //success
                Titanium.App.Properties.setString('geotag', pos.coords.latitude+','+pos.coords.longitude);
                dial.setMessage('Your tweet has been geo-tagged!');
                dial.show();
            }
        );
    }
}

geolocation.addEventListener('click', function(){
    var geotag_enabled = Titanium.App.Properties.getString('geotag_enabled');
    dial.setTitle('Geolocation');
    if (geotag_enabled==undefined)
    {
        var ch = Titanium.Network.createHTTPClient();

        ch.onload = function()
		{
    		Titanium.API.log('Got it.');
    		var resp = JSON.parse(this.responseText);

            if (parseInt(this.status, 10)==200 && (resp.geo_enabled==true))
            {
                geotag_enabled = true;
                Titanium.App.Properties.setString('geotag_enabled', 'true');
                geoTagIt();
	        }
	        else
	        {
	            geotag_enabled = false;
	            checkDial.setTitle('Geolocation');
                checkDial.setMessage('Sorry, we cannot geotag your tweets until you enable it from twitter.com\'s settings. Click OK to visit twitter to do the same.');
                checkDial.show();
                checkDial.addEventListener('click',function(e)
        		{
        			if (e.index == 0)
        			{
                        var win = Titanium.UI.createWindow({
                	            url:'http://m.twitter.com/account/settings/geo',
                	            backgroundColor:'#fff',
                	            title:'Twitter.com'
                	        });
                	    win.open({animated:true});
        			}
        		});
	        }
    		win.setRightNavButton(send);
    		win.setTitle('What\'s on your mind?');
		};

		var user = String(Titanium.App.Properties.getString('user'));
    	var pass = String(Titanium.App.Properties.getString('pass'));
    	var screen_name = String(Titanium.App.Properties.getString('screen_name'));

		ch.open('GET','https://oauth.filttr.com/users/show.json?im=yes&screen_name='+screen_name);
		ch.setRequestHeader('Authorization', 'Basic ' + Titanium.Utils.base64encode(user + ':' + pass));

		Titanium.API.log('sending: ');
		ch.send({});
		tweetBox.focus();
    }
    
    if (geotag_enabled=='true')
    {
        geoTagIt();
    }
	
    
});

tcount.addEventListener('click',function()
{
    dial.setTitle('140 char limit');
    dial.setMessage('Twitter allows a maximum of 140 chars when you tweet. We maintain the count dynamically :)');
    dial.show();
});

var match = {};
var surl = {};
var tweet = '';
var c = 0;
var uc = 0;

function shortFromFilttr(curr, j){
    var data = curr.responseText;
    if (data!=match[j])
	{
		tweet = tweet.replace(match[j], data);
		uc++;
        if (uc==c)
        {
			tweetBox.setValue(tweet);
        	Titanium.App.Properties.setString('draftText', tweet);
        	tweetLength = 140-tweet.length;
        	tcount.title=String(tweetLength);
        	dial.setTitle('URL Shortener');
            dial.setMessage('Sorry, could not shorten any URL!');
            if (c==1)
            {
    		    dial.setMessage("1 URL shortened!");
        	}
        	else
        	{
    		    dial.setMessage(c+" URLs shortened!");
            }
            dial.show();
        }
	}
}

function shorten(){
	//convert URLs
	c = 0;
	uc = 0;
	tweet = tweetBox.value;
	match = tweet.match(/(http|https|ftp)(\S+[^()<>{},\.\s])/g);
    surl = {};
	if(match != null)
	{
		for(i=0;i<match.length;i++)
		{
			if(match[i].length <= 18)
			{
				continue;
			}
			else
			{
				c++;
				surl[i] = Titanium.Network.createHTTPClient();
				//yes, this will throw a warning with JSLint and I don't care.
				with ({num: i})
			    {
                    surl[i].onload = function() {shortFromFilttr(this, num);};
                }
                
                // open the client
                surl[i].open('POST', 'http://a.oauth.filttr.com/filttrfon_short_url.php?im=yes');
				
				Titanium.API.log('Shortening URL '+c+' | '+match[i]);

                var user = String(Titanium.App.Properties.getString('user'));
            	var pass = String(Titanium.App.Properties.getString('pass'));

        		surl[i].setRequestHeader('Authorization', 'Basic ' + Titanium.Utils.base64encode(user + ':' + pass));
        		
        		surl[i].send({'url': match[i]});
			}
		}
	}
	if (c==0 || match == null)
    {
        dial.setTitle('URL Shortener');
        dial.setMessage('Sorry, could not shorten any URL!');
        dial.show();
    }
	
}

urlshortener.addEventListener('click',function()
{
    shorten();
});

closeB.addEventListener('click',function()
{
    savedText = tweetBox.value;
    temp = Titanium.App.Properties.getString('skipTweetCheck');
    if (temp==1 || savedText=='')
    {
        win.close();
    }
    else
    {
        var dialog = Titanium.UI.createOptionDialog();
		dialog.setOptions(["Save ","Discard","Cancel"]);
		dialog.setDestructive(1);
		dialog.setCancel(2);

		dialog.setTitle('You seem to have typed a tweet.');
		dialog.addEventListener('click',function(e)
		{
			switch(e.index)
			{
			    case 0:
    			    savedText = tweetBox.value;
    			    Titanium.App.Properties.setString('draftText', savedText);
			        win.close();
			        break;

			    case 1:
			        tweetBox.setValue('');
			        Titanium.App.Properties.setString('draftText', '');
			        Titanium.App.Properties.setString('geotag', '');
			        win.close();
			        break;
			}
		});
		dialog.show();
    }
});

send.addEventListener('click',function()
{
    dial.setTitle('Oops?');
	if (tweetLength>140)
	{
	    dial.setMessage('Sorry, Twitter only allows a max upto 140 characters. You have entered: '+tweetLength);
        dial.show();
	}
	else
	{
	    temp = tweetBox.value;
		temp = temp.replace(/^\s+|\s+$/g,'');
		Titanium.API.log(temp);

		if (temp=='')
		{
            dial.setMessage('Nothing to tweet.');
            dial.show();
		}
		else
		{
		    navtitle.title = 'Sending tweet..';
            temp = encodeURIComponent(temp);

		    var ch = Titanium.Network.createHTTPClient();

            ch.onload = function()
    		{
        		Titanium.API.log('Got it.');
        		Titanium.API.log('Status: '+this.status);
                if (parseInt(this.status, 10)==200)
                {
                    tweetBox.setValue('');
                    Titanium.App.Properties.setString('draftText', '');
                    Titanium.App.Properties.setString('geotag', '');
			        win.close();
		        }
		        else
		        {
		            navtitle.title = 'What\'s on your mind?';
		            dial.setMessage('Something went wrong. Try again?');
                    dial.show();
		        }
    		};

    		var user = String(Titanium.App.Properties.getString('user'));
        	var pass = String(Titanium.App.Properties.getString('pass'));
        	
    		ch.open('POST','https://oauth.filttr.com/statuses/update.json?im=yes');
    		ch.setRequestHeader('Authorization', 'Basic ' + Titanium.Utils.base64encode(user + ':' + pass));


    		Titanium.API.log('sending: '+temp);

        	//I haz geotagggggg?
        	var geotag = Titanium.App.Properties.getString('geotag');
        	if (geotag==undefined || geotag=='')
        	{
        	    ch.send({status:temp, source:'FilttrFon'});
    	    }
    		else
    		{
    		    ch.send({status:temp, source:'FilttrFon', geo:geotag});
            }
    		Titanium.API.log('waiting for response.');
		}
	}
	
});

clearB.addEventListener('click',function()
{
    checkDial.setTitle('Tweet');
    checkDial.setMessage('Clear what you\'ve typed so far?');
    checkDial.show();
    checkDial.addEventListener('click',function(e)
	{
		if (e.index == 0)
		{
            tweetBox.setValue('');
            Titanium.App.Properties.setString('draftText', '');
		}
	});

});

tweetBox.addEventListener('change',function(e)
{
	temp = String(tweetBox.value);
	Titanium.App.Properties.setString('draftText', temp);
	tweetLength = 140-temp.length;
	tcount.title=String(tweetLength);
});

tweetBox.focus();
//There's a stupid focus bug when using iOS 3.x.
setTimeout(function(){
    tweetBox.focus();
}, 500);

win.add(tweetBox);
win.add(toolbar);
    
    
