var win = Titanium.UI.currentWindow;
var dial = Titanium.UI.createAlertDialog();
var screen_name = '';
var prev_screen_name = '';
var user = '';
var pass = '';

function notYetImplemented()
{
    dial.setTitle('Oops!');
    dial.setMessage('Sorry, that feature has not yet been implemented!');
    dial.show();
}

win.addEventListener('focus',function()
{
	user = Titanium.App.Properties.getString('user');
	pass = Titanium.App.Properties.getString('pass');

	if (user==undefined || pass==undefined)
	{
        var setup = Titanium.UI.createWindow({url:'setup.js',title:'Setup Account'});
		setup.open({modal:true});
	}
	else
	{
    	screen_name = String(Titanium.App.Properties.getString('screen_name'));
        if (screen_name!=prev_screen_name)
        {
            prev_screen_name = screen_name;
    	    win.setTitle('@'+screen_name+'\'s DMs');
        }
        
	    lbutton = Titanium.UI.createButton({
    	    systemButton:Titanium.UI.iPhone.SystemButton.REFRESH
    	});

    	var rbutton = Titanium.UI.createButton({
    	    systemButton:Titanium.UI.iPhone.SystemButton.COMPOSE
    	});

    	win.setLeftNavButton(lbutton);
    	lbutton.addEventListener('click',function(e){
    		notYetImplemented();
    	});

    	win.setRightNavButton(rbutton);
    	rbutton.addEventListener('click',function(e){
            var win = Titanium.UI.createWindow({url:'compose.js',title:'What\'s on your mind?'});
			win.open({modal:true});
    	});
	}
});
	
