Titanium.include('common.js');
var prev_screen_name = '';
var timeline_type ='replies';

win.addEventListener('focus', function(){
    var screen_name = String(Titanium.App.Properties.getString('screen_name'));
    if (screen_name!=prev_screen_name)
    {
        prev_screen_name = screen_name;
        //win.setTitle('@'+screen_name+'\'s Mentions');
        win.setTitle('@'+screen_name);
        twitterid = parseInt(Titanium.App.Properties.getString('twitterid'), 10);
    }
    else
    {
        return;
    }

    var lbutton = Titanium.UI.createButton({
        systemButton:Titanium.UI.iPhone.SystemButton.REFRESH
    });

    var rbutton = Titanium.UI.createButton({
        systemButton:Titanium.UI.iPhone.SystemButton.COMPOSE
    });

    win.setLeftNavButton(lbutton);
    lbutton.addEventListener('click',function(e){
    	fetchTweets('replies');
    });

    win.setRightNavButton(rbutton);
    rbutton.addEventListener('click',function(e){
        compose = Titanium.UI.createWindow({url:'compose.js'});
    	compose.open({animate:true});
    });

    fetchTweets();
	setInterval(fetchTweets, 60000);
});