var user = Titanium.App.Properties.getString('user');
var pass = Titanium.App.Properties.getString('pass');
var cedit = false;
var dial = Titanium.UI.createAlertDialog();
var win = Titanium.UI.currentWindow;

dial.setTitle('Setup Account');

if (pass!=undefined)
{
    cedit = true;
}
else
{
    user = '';
    pass = '';
}
var userField = Titanium.UI.createTextField({
	value:user,
	color:'#336699',
	returnKeyType:Titanium.UI.RETURNKEY_NEXT,
	enableReturnKey:false,
	keyboardType:Titanium.UI.KEYBOARD_ASCII,
	autocorrect:false,
	hintText:'Type your Filttr Username',
	textAlign:'left',
	clearOnEdit:false,
	fontSize:20,
	height:40,
	top:10,
	borderStyle:Titanium.UI.INPUT_BORDERSTYLE_ROUNDED,
	clearButtonMode:Titanium.UI.INPUT_BUTTONMODE_ALWAYS
});

var passField = Titanium.UI.createTextField({
	value:pass,
	color:'#336699',
	returnKeyType:Titanium.UI.RETURNKEY_GO,
	enableReturnKey:true,
	keyboardType:Titanium.UI.KEYBOARD_ASCII,
	autocorrect:false,
	hintText:'Type your Filttr Password',
	textAlign:'left',
	passwordMask:true,
	clearOnEdit:cedit,
	height:35,
	top:70,
	borderStyle:Titanium.UI.INPUT_BORDERSTYLE_ROUNDED,
    clearButtonMode:Titanium.UI.INPUT_BUTTONMODE_ALWAYS
});

userField.addEventListener('return',function()
{
   passField.focus();
});

function signup()
{
    var win = Titanium.UI.createWindow({
            url:'https://oauth.filttr.com/signup/signup.php',
            backgroundColor:'#fff',
            title:'Filttr'
        });
    win.open({animated:true});
}

function verify()
{
    if (userField.value =='')
    {
        userField.focus();
    }
    else
    {
        if (passField.value == '')
        {
            passField.focus();
        }
        else
        {
    		passField.blur();
            var user = userField.value;
            var pass = Titanium.Utils.sha1(passField.value);
            
            win.setTitle('Verifying account..');
    		
            var ch = Titanium.Network.createHTTPClient();

            ch.onload = function()
    		{
        		Titanium.API.log('Got it.');
        		Titanium.API.log('Status: '+this.status);
        		temp = JSON.parse(this.responseText);
        		Titanium.API.log('Response: '+temp.screen_name);
	            win.setTitle('Setup Account');
                if (parseInt(this.status, 10)==200 && temp.screen_name!=undefined)
                {
                    Titanium.App.Properties.setString('screen_name', temp.screen_name);
                    Titanium.App.Properties.setString('twitterid', temp.id);
                    Titanium.App.Properties.setString('user', user);
                    Titanium.App.Properties.setString('pass', pass);
		            win.close();
		        }
		        else
		        {
		            dial.setMessage('Sorry, we couldn\'t verify your account. Please check your credentials.');
                    dial.show();
		        }
    		};

    		// open the client
    		
    		if (Titanium.Platform.model.indexOf("Simulator") == -1)
        	{
        		url = 'https://oauth.filttr.com/account/verify_credentials.json';
        	}
        	else
        	{
        		url = 'http://localhost/filttrfon/verify_credentials.php';
        	}

        	ch.open('GET',url+'?im=yes');
        	Titanium.API.log(url+'?im=yes');
        	
    		ch.setRequestHeader('Authorization', 'Basic ' + Titanium.Utils.base64encode(user + ':' + pass));


    		Titanium.API.log('verifying..');

    		// send the data
    		ch.send();

    		Titanium.API.log('waiting for response.');
        }
    }
}

passField.addEventListener('return', verify);

var send = Titanium.UI.createButton({
    systemButton:Titanium.UI.iPhone.SystemButton.DONE
});
win.setRightNavButton(send);

send.addEventListener('click', verify);

win.add(userField);
win.add(passField);